import "./organization-tree.css";
import { defineComponent as st, openBlock as g, createElementBlock as y, Fragment as x, normalizeClass as F, normalizeStyle as O, withModifiers as f, renderList as L, createElementVNode as T, toDisplayString as j, createCommentVNode as X, resolveComponent as gt, mergeProps as N, createBlock as V, Teleport as ft } from "vue";
import { _ as rt } from "../../_plugin-vue_export-helper-dad06003.js";
function pt(t, e) {
  if (t.match(/^[a-z]+:\/\//i))
    return t;
  if (t.match(/^\/\//))
    return window.location.protocol + t;
  if (t.match(/^[a-z]+:/i))
    return t;
  const n = document.implementation.createHTMLDocument(), o = n.createElement("base"), i = n.createElement("a");
  return n.head.appendChild(o), n.body.appendChild(i), e && (o.href = e), i.href = t, i.href;
}
const yt = (() => {
  let t = 0;
  const e = () => (
    // eslint-disable-next-line no-bitwise
    `0000${(Math.random() * 36 ** 4 << 0).toString(36)}`.slice(-4)
  );
  return () => (t += 1, `u${e()}${t}`);
})();
function E(t) {
  const e = [];
  for (let n = 0, o = t.length; n < o; n++)
    e.push(t[n]);
  return e;
}
function Y(t, e) {
  const o = (t.ownerDocument.defaultView || window).getComputedStyle(t).getPropertyValue(e);
  return o ? parseFloat(o.replace("px", "")) : 0;
}
function St(t) {
  const e = Y(t, "border-left-width"), n = Y(t, "border-right-width");
  return t.clientWidth + e + n;
}
function $t(t) {
  const e = Y(t, "border-top-width"), n = Y(t, "border-bottom-width");
  return t.clientHeight + e + n;
}
function at(t, e = {}) {
  const n = e.width || St(t), o = e.height || $t(t);
  return { width: n, height: o };
}
function Pt() {
  let t, e;
  try {
    e = process;
  } catch {
  }
  const n = e && e.env ? e.env.devicePixelRatio : null;
  return n && (t = parseInt(n, 10), Number.isNaN(t) && (t = 1)), t || window.devicePixelRatio || 1;
}
const v = 16384;
function Ct(t) {
  (t.width > v || t.height > v) && (t.width > v && t.height > v ? t.width > t.height ? (t.height *= v / t.width, t.width = v) : (t.width *= v / t.height, t.height = v) : t.width > v ? (t.height *= v / t.width, t.width = v) : (t.width *= v / t.height, t.height = v));
}
function B(t) {
  return new Promise((e, n) => {
    const o = new Image();
    o.decode = () => e(o), o.onload = () => e(o), o.onerror = n, o.crossOrigin = "anonymous", o.decoding = "async", o.src = t;
  });
}
async function wt(t) {
  return Promise.resolve().then(() => new XMLSerializer().serializeToString(t)).then(encodeURIComponent).then((e) => `data:image/svg+xml;charset=utf-8,${e}`);
}
async function vt(t, e, n) {
  const o = "http://www.w3.org/2000/svg", i = document.createElementNS(o, "svg"), r = document.createElementNS(o, "foreignObject");
  return i.setAttribute("width", `${e}`), i.setAttribute("height", `${n}`), i.setAttribute("viewBox", `0 0 ${e} ${n}`), r.setAttribute("width", "100%"), r.setAttribute("height", "100%"), r.setAttribute("x", "0"), r.setAttribute("y", "0"), r.setAttribute("externalResourcesRequired", "true"), i.appendChild(r), r.appendChild(t), wt(i);
}
const C = (t, e) => {
  if (t instanceof e)
    return !0;
  const n = Object.getPrototypeOf(t);
  return n === null ? !1 : n.constructor.name === e.name || C(n, e);
};
function bt(t) {
  const e = t.getPropertyValue("content");
  return `${t.cssText} content: '${e.replace(/'|"/g, "")}';`;
}
function kt(t) {
  return E(t).map((e) => {
    const n = t.getPropertyValue(e), o = t.getPropertyPriority(e);
    return `${e}: ${n}${o ? " !important" : ""};`;
  }).join(" ");
}
function Et(t, e, n) {
  const o = `.${t}:${e}`, i = n.cssText ? bt(n) : kt(n);
  return document.createTextNode(`${o}{${i}}`);
}
function Q(t, e, n) {
  const o = window.getComputedStyle(t, n), i = o.getPropertyValue("content");
  if (i === "" || i === "none")
    return;
  const r = yt();
  try {
    e.className = `${e.className} ${r}`;
  } catch {
    return;
  }
  const a = document.createElement("style");
  a.appendChild(Et(r, n, o)), e.appendChild(a);
}
function xt(t, e) {
  Q(t, e, ":before"), Q(t, e, ":after");
}
const _ = "application/font-woff", tt = "image/jpeg", Tt = {
  woff: _,
  woff2: _,
  ttf: "application/font-truetype",
  eot: "application/vnd.ms-fontobject",
  png: "image/png",
  jpg: tt,
  jpeg: tt,
  gif: "image/gif",
  tiff: "image/tiff",
  svg: "image/svg+xml",
  webp: "image/webp"
};
function It(t) {
  const e = /\.([^./]*?)$/g.exec(t);
  return e ? e[1] : "";
}
function K(t) {
  const e = It(t).toLowerCase();
  return Tt[e] || "";
}
function Rt(t) {
  return t.split(/,/)[1];
}
function J(t) {
  return t.search(/^(data:)/) !== -1;
}
function ct(t, e) {
  return `data:${e};base64,${t}`;
}
async function lt(t, e, n) {
  const o = await fetch(t, e);
  if (o.status === 404)
    throw new Error(`Resource "${o.url}" not found`);
  const i = await o.blob();
  return new Promise((r, a) => {
    const s = new FileReader();
    s.onerror = a, s.onloadend = () => {
      try {
        r(n({ res: o, result: s.result }));
      } catch (c) {
        a(c);
      }
    }, s.readAsDataURL(i);
  });
}
const Z = {};
function Mt(t, e, n) {
  let o = t.replace(/\?.*/, "");
  return n && (o = t), /ttf|otf|eot|woff2?/i.test(o) && (o = o.replace(/.*\//, "")), e ? `[${e}]${o}` : o;
}
async function G(t, e, n) {
  const o = Mt(t, e, n.includeQueryParams);
  if (Z[o] != null)
    return Z[o];
  n.cacheBust && (t += (/\?/.test(t) ? "&" : "?") + (/* @__PURE__ */ new Date()).getTime());
  let i;
  try {
    const r = await lt(t, n.fetchRequestInit, ({ res: a, result: s }) => (e || (e = a.headers.get("Content-Type") || ""), Rt(s)));
    i = ct(r, e);
  } catch (r) {
    i = n.imagePlaceholder || "";
    let a = `Failed to fetch resource: ${t}`;
    r && (a = typeof r == "string" ? r : r.message), a && console.warn(a);
  }
  return Z[o] = i, i;
}
async function Dt(t) {
  const e = t.toDataURL();
  return e === "data:," ? t.cloneNode(!1) : B(e);
}
async function Lt(t, e) {
  if (t.currentSrc) {
    const r = document.createElement("canvas"), a = r.getContext("2d");
    r.width = t.clientWidth, r.height = t.clientHeight, a == null || a.drawImage(t, 0, 0, r.width, r.height);
    const s = r.toDataURL();
    return B(s);
  }
  const n = t.poster, o = K(n), i = await G(n, o, e);
  return B(i);
}
async function Ot(t) {
  var e;
  try {
    if (!((e = t == null ? void 0 : t.contentDocument) === null || e === void 0) && e.body)
      return await U(t.contentDocument.body, {}, !0);
  } catch {
  }
  return t.cloneNode(!1);
}
async function Xt(t, e) {
  return C(t, HTMLCanvasElement) ? Dt(t) : C(t, HTMLVideoElement) ? Lt(t, e) : C(t, HTMLIFrameElement) ? Ot(t) : t.cloneNode(!1);
}
const At = (t) => t.tagName != null && t.tagName.toUpperCase() === "SLOT";
async function Ft(t, e, n) {
  var o, i;
  let r = [];
  return At(t) && t.assignedNodes ? r = E(t.assignedNodes()) : C(t, HTMLIFrameElement) && (!((o = t.contentDocument) === null || o === void 0) && o.body) ? r = E(t.contentDocument.body.childNodes) : r = E(((i = t.shadowRoot) !== null && i !== void 0 ? i : t).childNodes), r.length === 0 || C(t, HTMLVideoElement) || await r.reduce((a, s) => a.then(() => U(s, n)).then((c) => {
    c && e.appendChild(c);
  }), Promise.resolve()), e;
}
function Yt(t, e) {
  const n = e.style;
  if (!n)
    return;
  const o = window.getComputedStyle(t);
  o.cssText ? (n.cssText = o.cssText, n.transformOrigin = o.transformOrigin) : E(o).forEach((i) => {
    let r = o.getPropertyValue(i);
    i === "font-size" && r.endsWith("px") && (r = `${Math.floor(parseFloat(r.substring(0, r.length - 2))) - 0.1}px`), C(t, HTMLIFrameElement) && i === "display" && r === "inline" && (r = "block"), i === "d" && e.getAttribute("d") && (r = `path(${e.getAttribute("d")})`), n.setProperty(i, r, o.getPropertyPriority(i));
  });
}
function Bt(t, e) {
  C(t, HTMLTextAreaElement) && (e.innerHTML = t.value), C(t, HTMLInputElement) && e.setAttribute("value", t.value);
}
function Ht(t, e) {
  if (C(t, HTMLSelectElement)) {
    const n = e, o = Array.from(n.children).find((i) => t.value === i.getAttribute("value"));
    o && o.setAttribute("selected", "");
  }
}
function Ut(t, e) {
  return C(e, Element) && (Yt(t, e), xt(t, e), Bt(t, e), Ht(t, e)), e;
}
async function Wt(t, e) {
  const n = t.querySelectorAll ? t.querySelectorAll("use") : [];
  if (n.length === 0)
    return t;
  const o = {};
  for (let r = 0; r < n.length; r++) {
    const s = n[r].getAttribute("xlink:href");
    if (s) {
      const c = t.querySelector(s), l = document.querySelector(s);
      !c && l && !o[s] && (o[s] = await U(l, e, !0));
    }
  }
  const i = Object.values(o);
  if (i.length) {
    const r = "http://www.w3.org/1999/xhtml", a = document.createElementNS(r, "svg");
    a.setAttribute("xmlns", r), a.style.position = "absolute", a.style.width = "0", a.style.height = "0", a.style.overflow = "hidden", a.style.display = "none";
    const s = document.createElementNS(r, "defs");
    a.appendChild(s);
    for (let c = 0; c < i.length; c++)
      s.appendChild(i[c]);
    t.appendChild(a);
  }
  return t;
}
async function U(t, e, n) {
  return !n && e.filter && !e.filter(t) ? null : Promise.resolve(t).then((o) => Xt(o, e)).then((o) => Ft(t, o, e)).then((o) => Ut(t, o)).then((o) => Wt(o, e));
}
const ht = /url\((['"]?)([^'"]+?)\1\)/g, zt = /url\([^)]+\)\s*format\((["']?)([^"']+)\1\)/g, qt = /src:\s*(?:url\([^)]+\)\s*format\([^)]+\)[,;]\s*)+/g;
function jt(t) {
  const e = t.replace(/([.*+?^${}()|\[\]\/\\])/g, "\\$1");
  return new RegExp(`(url\\(['"]?)(${e})(['"]?\\))`, "g");
}
function Zt(t) {
  const e = [];
  return t.replace(ht, (n, o, i) => (e.push(i), n)), e.filter((n) => !J(n));
}
async function Jt(t, e, n, o, i) {
  try {
    const r = n ? pt(e, n) : e, a = K(e);
    let s;
    if (i) {
      const c = await i(r);
      s = ct(c, a);
    } else
      s = await G(r, a, o);
    return t.replace(jt(e), `$1${s}$3`);
  } catch {
  }
  return t;
}
function Kt(t, { preferredFontFormat: e }) {
  return e ? t.replace(qt, (n) => {
    for (; ; ) {
      const [o, , i] = zt.exec(n) || [];
      if (!i)
        return "";
      if (i === e)
        return `src: ${o};`;
    }
  }) : t;
}
function dt(t) {
  return t.search(ht) !== -1;
}
async function ut(t, e, n) {
  if (!dt(t))
    return t;
  const o = Kt(t, n);
  return Zt(o).reduce((r, a) => r.then((s) => Jt(s, a, e, n)), Promise.resolve(o));
}
async function A(t, e, n) {
  var o;
  const i = (o = e.style) === null || o === void 0 ? void 0 : o.getPropertyValue(t);
  if (i) {
    const r = await ut(i, null, n);
    return e.style.setProperty(t, r, e.style.getPropertyPriority(t)), !0;
  }
  return !1;
}
async function Gt(t, e) {
  await A("background", t, e) || await A("background-image", t, e), await A("mask", t, e) || await A("mask-image", t, e);
}
async function Nt(t, e) {
  const n = C(t, HTMLImageElement);
  if (!(n && !J(t.src)) && !(C(t, SVGImageElement) && !J(t.href.baseVal)))
    return;
  const o = n ? t.src : t.href.baseVal, i = await G(o, K(o), e);
  await new Promise((r, a) => {
    t.onload = r, t.onerror = a;
    const s = t;
    s.decode && (s.decode = r), s.loading === "lazy" && (s.loading = "eager"), n ? (t.srcset = "", t.src = i) : t.href.baseVal = i;
  });
}
async function Vt(t, e) {
  const o = E(t.childNodes).map((i) => mt(i, e));
  await Promise.all(o).then(() => t);
}
async function mt(t, e) {
  C(t, Element) && (await Gt(t, e), await Nt(t, e), await Vt(t, e));
}
function Qt(t, e) {
  const { style: n } = t;
  e.backgroundColor && (n.backgroundColor = e.backgroundColor), e.width && (n.width = `${e.width}px`), e.height && (n.height = `${e.height}px`);
  const o = e.style;
  return o != null && Object.keys(o).forEach((i) => {
    n[i] = o[i];
  }), t;
}
const et = {};
async function nt(t) {
  let e = et[t];
  if (e != null)
    return e;
  const o = await (await fetch(t)).text();
  return e = { url: t, cssText: o }, et[t] = e, e;
}
async function ot(t, e) {
  let n = t.cssText;
  const o = /url\(["']?([^"')]+)["']?\)/g, r = (n.match(/url\([^)]+\)/g) || []).map(async (a) => {
    let s = a.replace(o, "$1");
    return s.startsWith("https://") || (s = new URL(s, t.url).href), lt(s, e.fetchRequestInit, ({ result: c }) => (n = n.replace(a, `url(${c})`), [a, c]));
  });
  return Promise.all(r).then(() => n);
}
function it(t) {
  if (t == null)
    return [];
  const e = [], n = /(\/\*[\s\S]*?\*\/)/gi;
  let o = t.replace(n, "");
  const i = new RegExp("((@.*?keyframes [\\s\\S]*?){([\\s\\S]*?}\\s*?)})", "gi");
  for (; ; ) {
    const c = i.exec(o);
    if (c === null)
      break;
    e.push(c[0]);
  }
  o = o.replace(i, "");
  const r = /@import[\s\S]*?url\([^)]*\)[\s\S]*?;/gi, a = "((\\s*?(?:\\/\\*[\\s\\S]*?\\*\\/)?\\s*?@media[\\s\\S]*?){([\\s\\S]*?)}\\s*?})|(([\\s\\S]*?){([\\s\\S]*?)})", s = new RegExp(a, "gi");
  for (; ; ) {
    let c = r.exec(o);
    if (c === null) {
      if (c = s.exec(o), c === null)
        break;
      r.lastIndex = s.lastIndex;
    } else
      s.lastIndex = r.lastIndex;
    e.push(c[0]);
  }
  return e;
}
async function _t(t, e) {
  const n = [], o = [];
  return t.forEach((i) => {
    if ("cssRules" in i)
      try {
        E(i.cssRules || []).forEach((r, a) => {
          if (r.type === CSSRule.IMPORT_RULE) {
            let s = a + 1;
            const c = r.href, l = nt(c).then((h) => ot(h, e)).then((h) => it(h).forEach((u) => {
              try {
                i.insertRule(u, u.startsWith("@import") ? s += 1 : i.cssRules.length);
              } catch (m) {
                console.error("Error inserting rule from remote css", {
                  rule: u,
                  error: m
                });
              }
            })).catch((h) => {
              console.error("Error loading remote css", h.toString());
            });
            o.push(l);
          }
        });
      } catch (r) {
        const a = t.find((s) => s.href == null) || document.styleSheets[0];
        i.href != null && o.push(nt(i.href).then((s) => ot(s, e)).then((s) => it(s).forEach((c) => {
          a.insertRule(c, i.cssRules.length);
        })).catch((s) => {
          console.error("Error loading remote stylesheet", s);
        })), console.error("Error inlining remote css file", r);
      }
  }), Promise.all(o).then(() => (t.forEach((i) => {
    if ("cssRules" in i)
      try {
        E(i.cssRules || []).forEach((r) => {
          n.push(r);
        });
      } catch (r) {
        console.error(`Error while reading CSS rules from ${i.href}`, r);
      }
  }), n));
}
function te(t) {
  return t.filter((e) => e.type === CSSRule.FONT_FACE_RULE).filter((e) => dt(e.style.getPropertyValue("src")));
}
async function ee(t, e) {
  if (t.ownerDocument == null)
    throw new Error("Provided element is not within a Document");
  const n = E(t.ownerDocument.styleSheets), o = await _t(n, e);
  return te(o);
}
async function ne(t, e) {
  const n = await ee(t, e);
  return (await Promise.all(n.map((i) => {
    const r = i.parentStyleSheet ? i.parentStyleSheet.href : null;
    return ut(i.cssText, r, e);
  }))).join(`
`);
}
async function oe(t, e) {
  const n = e.fontEmbedCSS != null ? e.fontEmbedCSS : e.skipFonts ? null : await ne(t, e);
  if (n) {
    const o = document.createElement("style"), i = document.createTextNode(n);
    o.appendChild(i), t.firstChild ? t.insertBefore(o, t.firstChild) : t.appendChild(o);
  }
}
async function ie(t, e = {}) {
  const { width: n, height: o } = at(t, e), i = await U(t, e, !0);
  return await oe(i, e), await mt(i, e), Qt(i, e), await vt(i, n, o);
}
async function se(t, e = {}) {
  const { width: n, height: o } = at(t, e), i = await ie(t, e), r = await B(i), a = document.createElement("canvas"), s = a.getContext("2d"), c = e.pixelRatio || Pt(), l = e.canvasWidth || n, h = e.canvasHeight || o;
  return a.width = l * c, a.height = h * c, e.skipAutoScale || Ct(a), a.style.width = `${l}`, a.style.height = `${h}`, e.backgroundColor && (s.fillStyle = e.backgroundColor, s.fillRect(0, 0, a.width, a.height)), s.drawImage(r, 0, 0, a.width, a.height), a;
}
async function re(t, e = {}) {
  return (await se(t, e)).toDataURL();
}
const H = (t, e) => t < 1 ? {
  x: e.x + 5,
  y: e.y
} : t >= 1 && t <= 3 ? {
  x: e.x,
  y: e.y + 5
} : t >= 4 && t <= 6 ? {
  x: e.x,
  y: e.y - 5
} : {
  x: e.x - 5,
  y: e.y
}, ae = (t, e) => [...t].sort(
  (i, r) => {
    const a = Math.sqrt(
      (i.x - e.x) * (i.x - e.x) + (i.y - e.y) * (i.y - e.y)
    ), s = Math.sqrt(
      (r.x - e.x) * (r.x - e.x) + (r.y - e.y) * (r.y - e.y)
    );
    return a - s;
  }
).reverse(), ce = (t, e, n) => {
  const {
    canvasHeight: o,
    canvasWidth: i,
    x: r,
    y: a
  } = n, { from: s, points: c, to: l } = t, h = document.querySelector(
    `#org-${e} #org-${e}-item-${s.item}-io-${s.io}`
  ), u = document.querySelector(
    `#org-${e} #org-${e}-item-${l.item}-io-${l.io}`
  );
  if (h && u) {
    const {
      height: m,
      width: d,
      x: S,
      y: p
    } = h.getBoundingClientRect().toJSON(), {
      height: $,
      width: P,
      x: I,
      y: R
    } = u.getBoundingClientRect().toJSON(), b = d / 2 + (S - r) * i, k = m / 2 + (p - a) * o, w = P / 2 + (I - r) * i, W = $ / 2 + (R - a) * o, M = {
      ...H(s.io, {
        x: Math.round(b / 5) * 5,
        y: Math.round(k / 5) * 5
      })
    }, D = {
      ...H(l.io, {
        x: Math.round(w / 5) * 5,
        y: Math.round(W / 5) * 5
      })
    };
    if (c != null && c.length) {
      const z = c.map((Le, q) => q === c.length - 1 ? `L ${D.x} ${D.y}` : `L ${c[q + 1].x} ${c[q + 1].y}`).join(" ");
      return `M ${M.x} ${M.y} L ${c[0].x} ${c[0].y} ${z}`;
    }
    return `M ${M.x} ${M.y} L ${D.x} ${D.y}`;
  }
}, le = (t, e, n, o, i) => {
  const {
    canvasHeight: r,
    canvasWidth: a,
    x: s,
    y: c
  } = i, l = e.from.item === t, { from: h, to: u } = e, m = document.querySelector(
    `#org-${o} #org-${o}-item-${h.item}-io-${h.io}`
  ), d = document.querySelector(
    `#org-${o} #org-${o}-item-${u.item}-io-${u.io}`
  );
  if (!l && d && n && n[0]) {
    const {
      height: S,
      width: p,
      x: $,
      y: P
    } = d.getBoundingClientRect().toJSON(), I = p / 2 + ($ - s) * a, R = S / 2 + (P - c) * r, b = {
      ...H(u.io, {
        x: Math.round(I / 5) * 5,
        y: Math.round(R / 5) * 5
      })
    }, k = n[0].getAttribute("d");
    if (k) {
      const w = k.split(" ");
      return w[w.length - 2] = String(b.x), w[w.length - 1] = String(b.y), w.join(" ");
    }
  } else if (m && n && n[0]) {
    const {
      height: S,
      width: p,
      x: $,
      y: P
    } = m.getBoundingClientRect().toJSON(), I = p / 2 + ($ - s) * a, R = S / 2 + (P - c) * r, b = {
      ...H(h.io, {
        x: Math.round(I / 5) * 5,
        y: Math.round(R / 5) * 5
      })
    }, k = n[0].getAttribute("d");
    if (k) {
      const w = k.split(" ");
      return w[1] = String(b.x), w[2] = String(b.y), w.join(" ");
    }
  }
}, he = (t, e) => {
  if (e) {
    const n = e[0].getAttribute("d");
    if (n) {
      const o = n.split(" "), i = `L ${o[o.length - 2]} ${o[o.length - 1]}`, r = `M ${o[1]} ${o[2]}`;
      if (t != null && t.length) {
        const a = t.map((c) => `L ${c.x} ${c.y}`).join(" ");
        return `${r} ${a} ${i}`;
      }
      return `${r} ${i}`;
    }
  }
}, de = st({
  emits: {
    changePoint: (t, e) => !0,
    dragItem: (t) => !0,
    dragConnection: (t, e) => !0,
    dragPoint: (t, e) => !0,
    selectConnection: (t) => !0
  },
  props: {
    canvasState: {
      required: !0,
      type: Object
    },
    connectorState: {
      required: !0,
      type: Object
    },
    isDragged: {
      required: !1,
      type: Boolean
    },
    isEditable: {
      required: !1,
      type: Boolean
    },
    item: {
      required: !0,
      type: Object
    },
    selectedConnection: {
      required: !1,
      type: Object
    }
  },
  name: "sb-organization-tree-item",
  data() {
    return {
      connectionsPath: {}
    };
  },
  computed: {
    getItemPosition() {
      return {
        left: this.item.coordinates.x ? `${this.item.coordinates.x}px` : 0,
        top: this.item.coordinates.y ? `${this.item.coordinates.y}px` : 0
      };
    },
    isConnecting() {
      return this.connectorState.from ? this.connectorState.from.split("-io-")[0] === this.$.vnode.key : !1;
    }
  },
  methods: {
    getConnectionPath(t) {
      if (this.canvasState.elem) {
        const e = String(this.$.vnode.key).split("-item-")[0].replace("org-", ""), n = this.canvasState.elem.getBoundingClientRect().toJSON(), o = n.height || 0, i = n.width || 0, r = i / (i * this.canvasState.zoom) || 0, a = o / (o * this.canvasState.zoom) || 0;
        return ce(t, e, {
          canvasHeight: a,
          canvasWidth: r,
          x: n.x,
          y: n.y
        });
      }
    },
    getConnectionPathString(t) {
      return this.connectionsPath[`${String(this.$.vnode.key)}-connection-${t.from.item}-${t.from.io}-${t.to.item}-${t.to.io}`];
    },
    getCoordinatesMove(t) {
      return t.type === "touchstart" ? {
        x: t.touches[0].clientX,
        y: t.touches[0].clientY
      } : {
        x: t.clientX,
        y: t.clientY
      };
    },
    handleCircleDoubleClick(t, e) {
      var n;
      if (this.isEditable) {
        const o = [
          ...this.item.connections || []
        ], i = [
          ...((n = o[t]) == null ? void 0 : n.points) || []
        ];
        i.splice(e, 1), o[t] = {
          ...o[t],
          points: [...i]
        };
        const r = Number(
          String(this.$.vnode.key).split("-item-")[1]
        );
        this.$emit(
          "changePoint",
          {
            ...this.item,
            connections: [...o]
          },
          r
        );
      }
    },
    handleClickIO(t, e) {
      const n = t.target;
      if (n && this.isEditable) {
        const o = n.getBoundingClientRect();
        this.$emit(
          "dragConnection",
          `${String(this.$.vnode.key)}-io-${e}`,
          o
        );
      }
    },
    handleClickPoint(t, e, n) {
      const o = t.target;
      if (o && this.isEditable) {
        const i = o.getBoundingClientRect();
        this.$emit(
          "dragPoint",
          {
            connection: e,
            item: Number(
              String(this.$.vnode.key).split("-item-")[1]
            ),
            point: n
          },
          i
        );
      }
    },
    handleConnectionClick(t, e) {
      if (this.isEditable && t.target) {
        const n = {
          ...this.item.connections[e] || {}
        };
        this.$emit("selectConnection", {
          from: n.from,
          key: `${String(this.$.vnode.key)}-connection-${e}`,
          to: n.to
        });
      }
    },
    handleConnectionDoubleClick(t, e) {
      const n = [
        ...this.item.connections || []
      ], { elem: o, zoom: i } = this.canvasState;
      if (o && this.isEditable) {
        const { height: r, width: a, x: s, y: c } = o.getBoundingClientRect().toJSON(), l = t.clientX, h = t.clientY, u = l * (a / (a * i)) - s * (a / (a * i)), m = h * (r / (r * i)) - c * (r / (r * i)), d = String(this.$.vnode.key).split(
          "-item-"
        )[0], S = document.getElementById(
          `${d}-item-${n[e].to.item}-io-${n[e].to.io}`
        );
        if (S && this.canvasState.elem) {
          const {
            height: p,
            width: $,
            x: P,
            y: I
          } = S.getBoundingClientRect().toJSON(), {
            height: R,
            width: b,
            x: k,
            y: w
          } = this.canvasState.elem.getBoundingClientRect().toJSON(), W = $ / 2 + (P - k) * b, M = p / 2 + (I - w) * R, D = [
            ...ae(
              [
                ...n[e].points || [],
                {
                  x: u,
                  y: m
                }
              ],
              {
                x: W,
                y: M
              }
            )
          ];
          n[e] = {
            ...n[e],
            points: [...D]
          };
          const z = Number(
            String(this.$.vnode.key).split("-item-")[1]
          );
          this.$emit(
            "changePoint",
            {
              ...this.item,
              connections: [...n]
            },
            z
          );
        }
      }
    },
    handleInitConnections() {
      this.item.connections && (this.connectionsPath = {}, this.item.connections.forEach((t) => {
        const e = this.getConnectionPath(t);
        this.connectionsPath[`${String(this.$.vnode.key)}-connection-${t.from.item}-${t.from.io}-${t.to.item}-${t.to.io}`] = e;
      }));
    },
    handleItemClick(t) {
      if (!t.target.classList.contains("io") && this.isEditable) {
        const n = this.getCoordinatesMove(t);
        this.$emit("dragItem", {
          coordinates: n,
          elem: this.$el.nextSibling,
          key: this.$.vnode.key
        });
      }
    },
    isConnectionSelected(t) {
      return this.selectedConnection ? `${String(this.$.vnode.key)}-connection-${t}` === this.selectedConnection.key : !1;
    }
  },
  mounted() {
    this.handleInitConnections();
  },
  watch: {
    "item.connections": {
      deep: !0,
      handler(t, e) {
        if (t && e && t.length < e.length) {
          const n = [...t].map(
            (r) => `${String(this.$.vnode.key)}-connection-${r.from.item}-${r.from.io}-${r.to.item}-${r.to.io}`
          ), i = [...e].map(
            (r) => `${String(this.$.vnode.key)}-connection-${r.from.item}-${r.from.io}-${r.to.item}-${r.to.io}`
          ).find(
            (r) => n.indexOf(r) < 0
          );
          i && (delete this.connectionsPath[i], this.$nextTick(() => this.handleInitConnections()));
        } else if (t && e && t.length > e.length || !e && (t != null && t.length)) {
          const n = t[t.length - 1], o = this.getConnectionPath(n);
          this.connectionsPath[`${String(this.$.vnode.key)}-connection-${n.from.item}-${n.from.io}-${n.to.item}-${n.to.io}`] = o;
        }
      }
    }
  }
}), ue = ["id"], me = ["id", "onMousedown", "onTouchstart"], ge = { class: "text" }, fe = ["id"], pe = ["id", "onMousedown", "onTouchstart"], ye = { class: "data-wrapper" }, Se = { class: "name" }, $e = { class: "position" }, Pe = ["innerHTML"], Ce = ["id"], we = ["d", "onClick", "onDblclick"], ve = ["cx", "cy", "onDblclick", "onMousedown", "onTouchstart"];
function be(t, e, n, o, i, r) {
  return g(), y(x, null, [
    t.item.department ? (g(), y("div", {
      key: 0,
      class: F(["department", {
        connecting: t.isConnecting,
        draggable: t.isEditable,
        dragged: t.isDragged
      }]),
      id: String(t.$.vnode.key),
      style: O(t.getItemPosition),
      onMousedown: e[0] || (e[0] = f((...a) => t.handleItemClick && t.handleItemClick(...a), ["stop"])),
      onTouchstart: e[1] || (e[1] = f((...a) => t.handleItemClick && t.handleItemClick(...a), ["stop"]))
    }, [
      (g(!0), y(x, null, L([...Array(8).keys()], (a) => (g(), y("span", {
        class: "io",
        id: `${String(t.$.vnode.key)}-io-${a}`,
        key: `io-${a}`,
        onMousedown: f((s) => t.handleClickIO(s, a), ["stop"]),
        onTouchstart: f((s) => t.handleClickIO(s, a), ["stop"])
      }, null, 40, me))), 128)),
      T("div", ge, j(t.item.department), 1)
    ], 46, ue)) : (g(), y("div", {
      key: 1,
      class: F(["card", {
        connecting: t.isConnecting,
        draggable: t.isEditable,
        dragged: t.isDragged
      }]),
      id: String(t.$.vnode.key),
      style: O(t.getItemPosition),
      onMousedown: e[2] || (e[2] = f((...a) => t.handleItemClick && t.handleItemClick(...a), ["stop"])),
      onTouchstart: e[3] || (e[3] = f((...a) => t.handleItemClick && t.handleItemClick(...a), ["stop"]))
    }, [
      (g(!0), y(x, null, L([...Array(8).keys()], (a) => (g(), y("span", {
        class: "io",
        id: `${String(t.$.vnode.key)}-io-${a}`,
        key: `io-${a}`,
        onMousedown: f((s) => t.handleClickIO(s, a), ["stop"]),
        onTouchstart: f((s) => t.handleClickIO(s, a), ["stop"])
      }, null, 40, pe))), 128)),
      t.item.photo ? (g(), y("div", {
        key: 0,
        class: "item-photo",
        style: O({
          backgroundImage: `url(${t.item.photo})`
        })
      }, null, 4)) : X("", !0),
      T("div", ye, [
        T("p", Se, j(t.item.name), 1),
        T("p", $e, j(t.item.position), 1),
        t.item.additionalInfo ? (g(), y("div", {
          key: 0,
          innerHTML: t.item.additionalInfo
        }, null, 8, Pe)) : X("", !0)
      ])
    ], 46, fe)),
    (g(!0), y(x, null, L(t.item.connections || [], (a, s) => (g(), y("svg", {
      class: F(["connection", {
        editable: t.isEditable,
        selected: t.isConnectionSelected(s)
      }]),
      xmlns: "http://www.w3.org/2000/svg",
      id: `${String(t.$.vnode.key)}-connection-${s}`,
      key: `${String(t.$.vnode.key)}-connection-${s}`
    }, [
      T("path", {
        d: t.getConnectionPathString(a),
        onClick: f((c) => t.handleConnectionClick(c, s), ["stop"]),
        onDblclick: f((c) => t.handleConnectionDoubleClick(c, s), ["stop"])
      }, null, 40, we),
      (g(!0), y(x, null, L(a.points || [], (c, l) => (g(), y("circle", {
        class: "circle",
        r: "4",
        cx: c.x,
        cy: c.y,
        key: `${String(
          t.$.vnode.key
        )}-connection-${s}-circle-${l}`,
        onDblclick: f((h) => t.handleCircleDoubleClick(s, l), ["stop"]),
        onMousedown: f((h) => t.handleClickPoint(h, s, l), ["stop"]),
        onTouchstart: f((h) => t.handleClickPoint(h, s, l), ["stop"])
      }, null, 40, ve))), 128))
    ], 10, Ce))), 128))
  ], 64);
}
const ke = /* @__PURE__ */ rt(de, [["render", be]]), Ee = st({
  emits: {
    change: (t) => !0
  },
  props: {
    isEditable: {
      required: !1,
      type: Boolean
    },
    list: {
      required: !0,
      type: Object
    }
  },
  name: "sb-organization-tree",
  components: {
    "sb-org-tree-item": ke
  },
  data() {
    return {
      canvasState: {
        coordinates: {
          x: 0,
          y: 0
        },
        elem: null,
        lastZoom: 1,
        zoom: 1
      },
      canvasStyle: {},
      connectorState: {
        from: null,
        fromRect: null,
        toCoordinates: null
      },
      draggedItem: null,
      exportAreaStyle: {},
      isExporting: !1,
      localList: [],
      mouseState: {
        mouse: {
          x: 0,
          y: 0
        },
        position: {
          x: 0,
          y: 0
        },
        positionStart: {
          x: 0,
          y: 0
        }
      },
      parentPointerState: {
        events: [],
        prevDiff: -1
      },
      parentState: {
        isDrag: !1,
        position: {
          x: 0,
          y: 0
        }
      },
      pointState: {
        fromRect: null,
        target: null,
        toCoordinates: null
      },
      selectedConnection: null
    };
  },
  computed: {
    getMinMaxXY() {
      const e = [...[...this.localList].flatMap(
        (d) => d.connections ? [...d.connections] : []
      )].flatMap(
        (d) => d.points ? [...d.points] : []
      ), n = [...this.localList].map(
        (d) => d.coordinates
      ), o = [...n].map(
        (d) => d.x
      ), i = [...n].map(
        (d) => d.x + 220
      ), r = [...n].map(
        (d) => d.y
      ), a = [...n].map(
        (d) => d.y + 100
      ), s = [
        ...[...e].map((d) => d.x),
        ...o,
        ...i
      ], c = [
        ...[...e].map((d) => d.y),
        ...r,
        ...a
      ], l = Math.max.apply(null, s), h = Math.min.apply(null, s), u = Math.max.apply(null, c), m = Math.min.apply(null, c);
      return {
        maxX: l,
        minX: h,
        maxY: u,
        minY: m
      };
    }
  },
  methods: {
    async doExport() {
      this.isExporting = !0, await new Promise(
        (s) => setTimeout(() => {
          s(!0);
        }, 200)
      );
      const { maxX: t, minX: e, maxY: n, minY: o } = this.getMinMaxXY, i = Math.abs(o) + n, r = Math.abs(e) + t, a = this.canvasState.elem;
      if (this.exportAreaStyle = {
        height: `${i + 40}px`,
        width: `${r + 40}px`
      }, a) {
        const s = a.cloneNode(
          !0
        );
        s.classList.remove("connection-selected"), s.style.transform = "none", s.style.background = "transparent", s.style.height = `${i}px`, s.style.position = "relative", s.style.width = `${r}px`;
        const c = document.getElementById(
          `org-${this.$.uid}-export-area`
        );
        if (c) {
          c.appendChild(s);
          const l = await re(
            c,
            {
              style: {
                opacity: "1"
              }
            }
          ).catch(() => null);
          return s.remove(), this.isExporting = !1, l;
        }
      }
      return null;
    },
    doParentZoom(t) {
      this.canvasState.zoom += t, this.$nextTick(() => this.doParentZoomRefresh());
    },
    doParentZoomRefresh() {
      const { coordinates: t, lastZoom: e, zoom: n } = this.canvasState, o = t.x / e * n, i = t.y / e * n;
      this.canvasState.lastZoom = n, this.canvasStyle = {
        transform: `translate(${o}px, ${i}px) scale(${n})`
      };
    },
    doSetTempConnectionPath() {
      if (this.connectorState.toCoordinates && this.connectorState.fromRect) {
        const { x: t, y: e } = this.connectorState.toCoordinates, {
          height: n,
          width: o,
          x: i,
          y: r
        } = this.connectorState.fromRect, { zoom: a } = this.canvasState, s = this.getCanvasRect(), c = (s == null ? void 0 : s.height) || 0, l = (s == null ? void 0 : s.width) || 0, h = l / (l * a) || 0, u = c / (c * a) || 0, m = (s == null ? void 0 : s.x) || 0, d = (s == null ? void 0 : s.y) || 0, S = o / 2 + (i - m) * h, p = n / 2 + (r - d) * u, $ = t * (l / (l * a)) - m * (l / (l * a)), P = e * (c / (c * a)) - d * (c / (c * a));
        this.connectorState.pathObject = {
          from: {
            x: S,
            y: p
          },
          to: {
            x: $,
            y: P
          }
        }, this.connectorState.path = `M ${S} ${p} L ${$} ${P}`;
      } else
        this.connectorState.pathObject = void 0, this.connectorState.path = void 0;
    },
    doUpdateItemMovedConnections(t) {
      this.localList.forEach(
        (e, n) => {
          [...e.connections || []].some(
            (o) => o.from.item === t || o.to.item === t
          ) && [...e.connections || []].forEach(
            (o, i) => {
              if (o.from.item === t || o.to.item === t) {
                const r = document.getElementById(
                  `org-${this.$.uid}-item-${n}-connection-${i}`
                ), a = r == null ? void 0 : r.getElementsByTagName(
                  "path"
                ), s = String(
                  this.$.uid
                ), c = this.getCanvasRect(), l = c.height || 0, h = c.width || 0, u = h / (h * this.canvasState.zoom) || 0, m = l / (l * this.canvasState.zoom) || 0, d = le(
                  t,
                  o,
                  a,
                  s,
                  {
                    canvasHeight: m,
                    canvasWidth: u,
                    x: c.x,
                    y: c.y
                  }
                );
                d && a && a[0].setAttributeNS(
                  null,
                  "d",
                  d
                );
              }
            }
          );
        }
      );
    },
    doUpdatePointMovedConnection(t, e, n) {
      const o = document.getElementById(
        `org-${this.$.uid}-item-${n}-connection-${e}`
      ), i = o == null ? void 0 : o.getElementsByTagName("path"), r = he(
        t,
        i
      );
      r && i && i[0].setAttributeNS(null, "d", r);
    },
    getCanvasRect() {
      return this.$refs["canvas-tree"] ? {
        ...this.$refs["canvas-tree"].getBoundingClientRect().toJSON()
      } : null;
    },
    getCoordinatesEnd(t) {
      return t.type === "touchend" ? {
        x: this.mouseState.mouse.x,
        y: this.mouseState.mouse.y
      } : {
        x: t.clientX,
        y: t.clientY
      };
    },
    getCoordinatesMove(t, e) {
      const n = e || 10, i = (() => t.type === "touchmove" || t.type === "touchstart" ? {
        x: t.touches[0].clientX,
        y: t.touches[0].clientY
      } : {
        x: t.clientX,
        y: t.clientY
      })();
      return e && e < 2 ? i : Math.abs(i.x - this.parentState.position.x) >= n || Math.abs(i.y - this.parentState.position.y) >= n ? {
        x: Math.round(i.x / n) * n,
        y: Math.round(i.y / n) * n
      } : this.parentState.position;
    },
    handleChangeItemPoint(t, e) {
      this.localList[e] = { ...t }, this.$nextTick(() => this.$emit("change", this.localList));
    },
    handleConnectionDragged(t, e) {
      this.connectorState.from = t, this.connectorState.fromRect = { ...e.toJSON() }, this.selectedConnection = null;
    },
    handleItemChangePosition(t) {
      if (this.draggedItem) {
        const e = Number(
          this.draggedItem.key.split("-item-")[1]
        ), n = [
          ...this.localList
        ], o = {
          ...n[e].coordinates
        };
        (o.x !== t.x || o.y !== t.y) && (n[e] = {
          ...this.localList[e],
          coordinates: t
        }, this.localList = [...n], this.$nextTick(
          () => this.doUpdateItemMovedConnections(e)
        ));
      }
    },
    handleItemDragged(t) {
      this.draggedItem = { ...t }, this.mouseState.position = { ...t.coordinates }, this.parentState.position = { ...t.coordinates }, this.selectedConnection = null;
    },
    handleParentClick(t) {
      const e = this.getCoordinatesMove(t, 1);
      this.selectedConnection = null, this.mouseState.mouse = { ...e }, this.mouseState.position = { ...e }, this.mouseState.positionStart = { ...e }, this.parentState.isDrag = !0;
    },
    handleParentDragEnd(t) {
      const { x: e, y: n } = this.getCoordinatesEnd(t), { coordinates: o } = this.canvasState, i = o.x + -(this.mouseState.position.x - e), r = o.y + -(this.mouseState.position.y - n);
      if (this.parentState.isDrag)
        this.canvasState.coordinates = {
          x: i,
          y: r
        };
      else if (this.connectorState.from) {
        const a = t.target;
        if (a.id !== this.connectorState.from && a.classList.contains("io") && !this.isConnectionExist(
          this.connectorState.from,
          a.id
        )) {
          const c = this.connectorState.from.split("-io-")[0], l = Number(
            this.connectorState.from.split("-io-")[1]
          ), h = Number(
            c.split("-item-")[1]
          ), u = a.id.split("-io-")[0], m = Number(
            a.id.split("-io-")[1]
          ), d = Number(
            u.split("-item-")[1]
          );
          if (this.localList[h] && this.localList[d] && this.connectorState.fromRect) {
            const S = [
              ...this.localList
            ];
            S[h].connections = [
              ...S[h].connections || [],
              {
                from: {
                  io: l,
                  item: h
                },
                to: {
                  io: m,
                  item: d
                }
              }
            ], this.localList = [...S];
          }
        }
      }
      this.$nextTick(() => {
        (this.draggedItem || this.pointState.target || this.connectorState.from) && this.$nextTick(
          () => this.$emit("change", this.localList)
        ), this.parentState.isDrag = !1, this.draggedItem = null, this.connectorState = {
          from: null,
          fromRect: null,
          path: void 0,
          toCoordinates: null
        }, this.pointState = {
          fromRect: null,
          target: null,
          toCoordinates: null
        };
      });
    },
    async handleParentKeydown(t) {
      if ((t.key === "Delete" || t.key === "Backspace") && this.selectedConnection) {
        t.preventDefault();
        const e = this.selectedConnection.key.split("-connection-");
        this.selectedConnection = null;
        const n = Number(
          e[0].split("-item-")[1]
        ), o = Number(e[1]);
        if (this.localList[n]) {
          const i = [
            ...this.localList[n].connections || []
          ];
          this.localList[n].connections = i.filter(
            (r, a) => a !== o
          ), this.$nextTick(() => {
            this.$emit("change", this.localList);
          });
        }
      }
    },
    handleParentPointerDown(t) {
      this.parentPointerState.events.push(t);
    },
    handleParentPointerMove(t) {
      this.parentPointerState.events = [
        ...this.parentPointerState.events
      ].map((e) => e.pointerId === t.pointerId ? t : e), this.$nextTick(() => {
        if (this.parentPointerState.events.length === 2) {
          const e = Math.abs(
            this.parentPointerState.events[0].clientX - this.parentPointerState.events[1].clientX
          );
          this.parentPointerState.prevDiff > 100 && e > this.parentPointerState.prevDiff ? this.doParentZoom(0.1) : this.parentPointerState.prevDiff > 100 && e < this.parentPointerState.prevDiff && this.doParentZoom(-0.1), this.parentPointerState.prevDiff = e;
        }
      });
    },
    handleParentPointerUp(t) {
      this.parentPointerState.events = [
        ...this.parentPointerState.events
      ].filter((e) => e.pointerId !== t.pointerId), this.$nextTick(() => {
        this.parentPointerState.events.length < 2 && (this.parentPointerState.prevDiff = -1);
      });
    },
    handleParentPosition(t) {
      const e = this.pointState.target ? 5 : this.connectorState.from ? 1 : 10, { x: n, y: o } = this.getCoordinatesMove(
        t,
        e
      ), { x: i, y: r } = this.parentState.position, { coordinates: a, zoom: s } = this.canvasState, c = this.getCanvasRect();
      if (this.parentState.isDrag) {
        const l = a.x + -(this.mouseState.position.x - n), h = a.y + -(this.mouseState.position.y - o);
        this.canvasStyle = {
          transform: `translate(${l}px, ${h}px) scale(${s})`
        };
      } else if (this.draggedItem) {
        t.preventDefault();
        const { x: l, y: h } = this.mouseState.position, u = (l - n) * ((c == null ? void 0 : c.width) || 0) / (((c == null ? void 0 : c.width) || 0) * s), m = (h - o) * ((c == null ? void 0 : c.height) || 0) / (((c == null ? void 0 : c.height) || 0) * s);
        this.handleItemChangePosition({
          x: Math.round(
            (this.draggedItem.elem.offsetLeft - u) / 10
          ) * 10,
          y: Math.round(
            (this.draggedItem.elem.offsetTop - m) / 10
          ) * 10
        }), this.$nextTick(() => this.mouseState.position = { x: n, y: o });
      } else if (this.connectorState.from)
        this.connectorState.toCoordinates = {
          x: n,
          y: o
        }, this.$nextTick(() => this.doSetTempConnectionPath());
      else if (this.pointState.target && this.canvasState.elem && (n !== i || o !== r)) {
        const {
          height: l,
          width: h,
          x: u,
          y: m
        } = this.canvasState.elem.getBoundingClientRect().toJSON(), d = n * (h / (h * s)) - u * (h / (h * s)), S = o * (l / (l * s)) - m * (l / (l * s)), { target: p } = this.pointState, $ = [
          ...this.localList[p.item].connections || []
        ], P = [
          ...$[p.connection].points || []
        ];
        P[p.point] = {
          x: Math.round(d / 5) * 5,
          y: Math.round(S / 5) * 5
        }, this.doUpdatePointMovedConnection(
          [...P],
          p.connection,
          p.item
        ), $[p.connection] = {
          ...$[p.connection],
          points: [...P]
        }, this.localList[p.item].connections = [
          ...$
        ];
      }
      this.parentState.position = {
        x: n,
        y: o
      }, t.type === "touchmove" && (this.mouseState.mouse = {
        x: n,
        y: o
      });
    },
    handleParentZoom(t) {
      t.ctrlKey && (t.preventDefault(), t.deltaY > 0 && this.canvasState.zoom > 0.5 ? this.doParentZoom(-0.1) : this.canvasState.zoom < 1.6 && this.doParentZoom(0.1));
    },
    handlePointDragged(t, e) {
      this.pointState.target = { ...t }, this.pointState.fromRect = { ...e.toJSON() };
    },
    handleSelectConnection(t) {
      this.selectedConnection = { ...t };
    },
    isConnectionExist(t, e) {
      return [...this.localList].flatMap(
        (o) => o.connections ? [...o.connections] : []
      ).some((o) => {
        const i = `org-${this.$.uid}-item-${o.from.item}-io-${o.from.io}`, r = `org-${this.$.uid}-item-${o.to.item}-io-${o.to.io}`;
        return t === i && e === r || t === r && e === i;
      });
    },
    isItemDragged(t) {
      var e;
      return ((e = this.draggedItem) == null ? void 0 : e.key) === t;
    }
  },
  watch: {
    list: {
      deep: !0,
      handler(t) {
        this.localList = [...t];
      },
      immediate: !0
    }
  },
  mounted() {
    this.$refs["canvas-tree"] && (this.canvasState.elem = this.$refs["canvas-tree"]), document.addEventListener("keydown", this.handleParentKeydown);
  },
  unmounted() {
    this.canvasState.elem = null, document.removeEventListener("keydown", this.handleParentKeydown);
  },
  expose: ["doExport"]
});
const xe = ["id"], Te = {
  key: 0,
  class: "connection connecting",
  xmlns: "http://www.w3.org/2000/svg"
}, Ie = ["d"], Re = ["id"];
function Me(t, e, n, o, i, r) {
  const a = gt("sb-org-tree-item");
  return g(), y(x, null, [
    T("div", N({
      class: [{
        connecting: t.connectorState.from,
        dragging: t.parentState.isDrag
      }, "organization-wrapper"],
      id: `org-${t.$.uid}`
    }, { ...t.$attrs }, {
      onMousedown: e[0] || (e[0] = f((...s) => t.handleParentClick && t.handleParentClick(...s), ["stop"])),
      onMousemove: e[1] || (e[1] = f((...s) => t.handleParentPosition && t.handleParentPosition(...s), ["stop"])),
      onMouseup: e[2] || (e[2] = f((...s) => t.handleParentDragEnd && t.handleParentDragEnd(...s), ["stop"])),
      onPointercancel: e[3] || (e[3] = (...s) => t.handleParentPointerUp && t.handleParentPointerUp(...s)),
      onPointerdown: e[4] || (e[4] = (...s) => t.handleParentPointerDown && t.handleParentPointerDown(...s)),
      onPointerleave: e[5] || (e[5] = (...s) => t.handleParentPointerUp && t.handleParentPointerUp(...s)),
      onPointermove: e[6] || (e[6] = (...s) => t.handleParentPointerMove && t.handleParentPointerMove(...s)),
      onPointerout: e[7] || (e[7] = (...s) => t.handleParentPointerUp && t.handleParentPointerUp(...s)),
      onPointerup: e[8] || (e[8] = (...s) => t.handleParentPointerUp && t.handleParentPointerUp(...s)),
      onTouchend: e[9] || (e[9] = f((...s) => t.handleParentDragEnd && t.handleParentDragEnd(...s), ["stop"])),
      onTouchmove: e[10] || (e[10] = f((...s) => t.handleParentPosition && t.handleParentPosition(...s), ["stop"])),
      onTouchstart: e[11] || (e[11] = f((...s) => t.handleParentClick && t.handleParentClick(...s), ["stop"])),
      onWheel: e[12] || (e[12] = f((...s) => t.handleParentZoom && t.handleParentZoom(...s), ["stop"]))
    }), [
      T("div", {
        class: F(["canvas", {
          "connection-selected": t.selectedConnection
        }]),
        ref: "canvas-tree",
        style: O(t.canvasStyle)
      }, [
        t.canvasState.elem ? (g(), y(x, { key: 0 }, [
          (g(!0), y(x, null, L(t.localList, (s, c) => (g(), V(a, N({
            "canvas-state": t.canvasState,
            "connector-state": t.connectorState,
            "is-dragged": t.isItemDragged(`org-${t.$.uid}-item-${c}`),
            key: `org-${t.$.uid}-item-${c}`,
            "selected-connection": t.selectedConnection
          }, {
            isEditable: t.isEditable,
            item: s
          }, {
            onChangePoint: t.handleChangeItemPoint,
            onDragConnection: t.handleConnectionDragged,
            onDragItem: t.handleItemDragged,
            onDragPoint: t.handlePointDragged,
            onSelectConnection: t.handleSelectConnection
          }), null, 16, ["canvas-state", "connector-state", "is-dragged", "selected-connection", "onChangePoint", "onDragConnection", "onDragItem", "onDragPoint", "onSelectConnection"]))), 128)),
          t.connectorState.from ? (g(), y("svg", Te, [
            T("path", {
              d: t.connectorState.path
            }, null, 8, Ie)
          ])) : X("", !0)
        ], 64)) : X("", !0)
      ], 6)
    ], 16, xe),
    (g(), V(ft, { to: "body" }, [
      t.isExporting ? (g(), y("div", {
        key: 0,
        class: "export-area-org-chart",
        id: `org-${t.$.uid}-export-area`,
        style: O(t.exportAreaStyle)
      }, null, 12, Re)) : X("", !0)
    ]))
  ], 64);
}
const Ae = /* @__PURE__ */ rt(Ee, [["render", Me]]);
export {
  Ae as default
};
